Katello - Bug #23993

Filtering of some entities does not work
06/19/2018 07:29 AM - Ivan Necas

Status: Closed
Priority: Normal
Assignee: Christine Fouant
Category: Hammer
Target version: Katello 3.7.1
Difficulty: Fixed in Releases:
Triaged: Yes Found in Releases:
Bugzilla link: 1584785 Red Hat JIRA:
Pull request: https://github.com/Katello/hammer-cli-kat
ello/pull/574
Description

Cloned from https://bugzilla.redhat.com/show_bug.cqi?id=1584785

Description of problem:
Some entities can only be specified using --<entity>-id because when specified by name by --<entity>, search doesn't query for the
name entered and returns multiple results. | discovered this for images and compute resources.

By using 'hammer -d', | discovered the correct request and response (for the entity which works) are:

[DEBUG 2018-05-31T12:08:08 API] Headers: {
:params => {

:search => "name = \"Kickstart default\""

1

}
[DEBUG 2018-05-31T12:08:08 API] Response: {

"total" => 14,

"subtotal" => 1,

"page" => 1,

"per_page" => 20,

"search" => "name = \"Kickstart default\"",

"sort" => {
"by" => nil,
"order" => nil

b

Notice the request is in form ":search => "name = \"Kickstart default\"" and response shows non-nil 'search' param.
And the incorrect ones are:

[DEBUG 2018-05-31T12:08:08 API] Headers: {
:params => {

"compute_resource_id" => 1,
"operatingsystem_id" => 1,

"name" => "fish"

}

}
[DEBUG 2018-05-31T12:08:09 API] Response: {

"total" => 2,
"subtotal" => 2,
"page" => 1,
"per_page" => 20,
"search" => nil,
"sort" => {

"by" => nil,
"order" => nil

b
Notice the request is wrongly in form "name" => "fish™ and 'search' in response is nil.

Version-Release number of selected component (if applicable):
Tested on Sat 6.4 snap 5

How reproducible:
Deterministic

Steps to Reproduce:

1. hammer host create --compute-resource-id 1 ...
Actual results:
Could not create the host:

Error: Found more than one image.

Expected results:
Same as specifying the entity (compute resource in this case) by id

Additional info:

Related issues:

Related to Katello - Bug #15701: Allow Foreman objects to resolve using “crea... Closed 07/15/2016
Related to Katello - Bug #24063: Investigate running hammer-cli-foreman tests... New 06/25/2018
Related to Katello - Refactor #26027: hammer_cli_katello resolvers interfere ... New

Copied to Katello - Bug #25027: Filtering of some entities does not work Closed

Associated revisions

Revision 31e2fb82 - 08/13/2018 12:31 PM - Christine Fouant
fixes #23993 - fixes entity filtering by adding searchables (#574)

History

#1 - 06/19/2018 07:43 AM - Tomas Strachota

- Subject changed from Filtering of some entities does not work
to Filtering of some entities does not work

- Status changed from New to Need more information

The issue description doesn't mention what commands are actually broken. Waiting for more information form the original BZ.

#2 - 06/25/2018 12:59 PM - lvan Necas
- Project changed from Hammer CLI to Katello
- Category changed from Other commands to Hammer

- Status changed from Need more information to New

One such an example is:

hammer -d host create --compute-resource 'blacr' --name 'bla' --environment="test" --architecture='x86_64"' —--d
omain local.test --operatingsystem 'RedHat 7.5' —--partition-table='Kickstart default' --location='Default Loca
tion' --organization='Default Organization'

The issue only reproduces when katello plugin is enabled, therefore changing the component to Katello.

#3 - 06/25/2018 03:52 PM - lvan Necas

- Related to Bug #15701: Allow Foreman objects to resolve using ‘create_search_options_creators_without_katello_api” added

#4 - 06/25/2018 03:56 PM - Ivan Necas

I've tracked the issue down to https:/projects.theforeman.org/issues/15701, where we started going down the road to override the foreman-related
resources in Katello.

Something else had to change as well, as compute resources were not causing issues before. Anyway, this approach proved itself to be quite risky
and | believe it should be reconsidered in hammer-cli-katello, as every searchable added to Foreman (and perhaps even to other plugins) will be
broken once Katello plugin is enabled.

#5 - 06/25/2018 04:27 PM - lvan Necas

- Related to Bug #24063: Investigate running hammer-cli-foreman tests with hammer-cli-katello loaded added

#6 - 06/27/2018 06:00 PM - Andrew Kofink

- translation missing: en.field_release set to 338

#7 - 06/27/2018 06:00 PM - Andrew Kofink

- translation missing: en.field_release changed from 338 to 349

#8 - 06/27/2018 06:01 PM - Andrew Kofink

- translation missing: en.field_release changed from 349 to 369

#9 - 08/08/2018 01:34 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Christine Fouant

- Pull request https://github.com/Katello/hammer-cli-katello/pull/574 added

#10 - 08/13/2018 01:01 PM - Christine Fouant
- Status changed from Ready For Testing to Closed

Applied in changeset hammer-cli-katello|31e2fb825d4ec563cc069850a785f1e79f0a31cf.

#11 - 09/24/2018 08:07 PM - Christine Fouant
- Copied to Bug #25027: Filtering of some entities does not work added

#12 - 02/11/2019 02:29 PM - Ivan Necas

- Related to Refactor #26027: hammer _cli_katello resolvers interfere with foreman onces on katello-extended resources added
